diff --git a/distrib/utils/sysinst/defs.h b/distrib/utils/sysinst/defs.h
index f47b3d4..6cae884 100644
--- a/distrib/utils/sysinst/defs.h
+++ b/distrib/utils/sysinst/defs.h
@@ -51,7 +51,7 @@ deconst(const void *p)
 
 #include "msg_defs.h"
 #include "menu_defs.h"
-#include "mbr.h"
+#include "mbr.h" // TODO: sss
 
 #define min(a,b)	((a) < (b) ? (a) : (b))
 #define max(a,b)	((a) > (b) ? (a) : (b))
@@ -84,6 +84,12 @@ deconst(const void *p)
 #define RUN_NO_CLEAR	0x0100		/* Leave program output after error */
 #define RUN_XFER_DIR	0x0200		/* cd to xfer_dir in child */
 
+/* for bsddisklabel.c */
+#define LY_SETNEW 1
+#define LY_NEWRAID 2
+#define LY_NEWCGD 3
+#define LY_USEEXIST 4
+
 /* Installation sets */
 enum {
     SET_NONE,
@@ -244,7 +250,7 @@ pid_t ttysig_forward;
 int layoutkind;
 int sizemult;
 const char *multname;
-int partman_go;   /* run partition manager */
+int partman_go; /* run extended partition manager */
 int fstab_prepared; /* Should we create new /etc/fstab or append old? */
 
 /* logging variables */
@@ -252,34 +258,35 @@ int fstab_prepared; /* Should we create new /etc/fstab or append old? */
 FILE *logfp;
 FILE *script;
 
-
-int rootpart;				/* partition we install into */
-const char *disktype;		/* ST506, SCSI, ... */
-unsigned int root_limit;    /* BIOS (etc) read limit */
-
 /* Information for the NetBSD disklabel */
+
 enum DLTR { PART_A, PART_B, PART_C, PART_D, PART_E, PART_F, PART_G, PART_H,
 	    PART_I, PART_J, PART_K, PART_L, PART_M, PART_N, PART_O, PART_P};
 #define partition_name(x)	('a' + (x))
 daddr_t tmp_ramdisk_size;
+#define MAX_DISKS 15
 
-#define DISKNAME_SIZE 16
-char bsddiskname[DISKNAME_SIZE]; // TODO: xxx
-const char *doessf;
+unsigned int root_limit;    /* BIOS (etc) read limit */
 
-/* Information for extended partition manager */
+/* All information that is unique for each drive */
+enum SHRED_T { SHRED_NONE=0, SHRED_ZEROS, SHRED_RANDOM, SHRED_CRYPTO };
 typedef struct pm_devs_t {
-    /* Actual name of the disk. */
-    char diskdev[SSTRSIZE];
+    int changed; /* Flag indicating to partman that device need saving */
+    int found; /* Flag to delete unplugged and unconfigured devices */
+    char diskdev[SSTRSIZE]; /* Actual name of the disk. */
     char diskdev_descr[STRSIZE];
     char id_dk[SSTRSIZE];
     int bootable;
+#define DISKNAME_SIZE 16
     char bsddiskname[DISKNAME_SIZE];
     partinfo oldlabel[MAXPARTITIONS]; /* What we found on the disk */
     partinfo bsdlabel[MAXPARTITIONS]; /* What we want it to look like */
     mbr_info_t mbr;
     int no_mbr; /* set for raid (etc) */
     int use_gpt;
+    int rootpart; /* partition we install into */
+    const char *disktype; /* ST506, SCSI, ... */
+    const char *doessf;
     /* Actual values for current disk - set by find_disks() or md_get_info() */
     int sectorsize, dlcyl, dlhead, dlsec, dlcylsize, current_cylsize;
     daddr_t dlsize;
@@ -287,18 +294,12 @@ typedef struct pm_devs_t {
     daddr_t ptstart, ptsize;
     /* If we have an MBR boot partition, start and size in sectors */
     int bootstart, bootsize;
+    struct ptn_info pi;
     struct pm_devs_t *next;
 } pm_devs_t;
-pm_devs_t *pm_devs; /* Pointer to head of list with all devices */
-pm_devs_t *pm_found; /* Pointer to selected in find_disks device
-                        (when extended partition manager isn't used) */
 pm_devs_t *pm; /* Pointer to currend device with which we work */
-
-#define MNTS_MAX 100
-struct {
-    const char *diskdev, *mnt_opts, *fsname;
-    char *pi_mount;
-} mnts[MNTS_MAX];
+pm_devs_t *pm_head; /* Pointer to head of list with all devices */
+pm_devs_t *pm_found; /* Pointer for next allocating device in find_disks() */
 
 /* Relative file name for storing a distribution. */
 char xfer_dir[STRSIZE];
@@ -412,15 +413,16 @@ int	make_fstab(void);
 int	mount_disks(void);
 int	set_swap(const char *, partinfo *);
 int	check_swap(const char *, int);
-char	*bootxx_name(void);
+char *bootxx_name(void);
+const char *fstype_name(int);
+void label_read(void);
+
+/* from partman.c */
 int	partman(void);
-int partman_adddisk(menudesc *, void *);
-int partman_addvnd(menudesc *, void *);
-int partman_deldev(menudesc *, void *);
-int partman_commit(menudesc *, void *);
-int partman_mountall(void);
-void partman_menufmt(menudesc *, int, void *);
-void partman_select(pm_devs_t *);
+int partman_mountmenu(void);
+int partman_shred(char *, int);
+int partman_unconfigure(void);
+int partman_cgd_edit_adddisk(int, pm_devs_t *);
 
 /* from disks_lfs.c */
 int	fs_is_lfs(void *);
@@ -508,6 +510,7 @@ void	replace(const char *, const char *, ...);
 void	get_tz_default(void);
 int	extract_file(distinfo *, int);
 void	do_coloring (unsigned int, unsigned int);
+int set_menu_select(menudesc *, void *);
 
 /* from target.c */
 #if defined(DEBUG)  ||	defined(DEBUG_ROOT)
diff --git a/distrib/utils/sysinst/disks.c b/distrib/utils/sysinst/disks.c
index be1c612..5400696 100644
--- a/distrib/utils/sysinst/disks.c
+++ b/distrib/utils/sysinst/disks.c
@@ -62,7 +62,6 @@
 #include "txtwalk.h"
 
 /* Disk descriptions */
-#define MAX_DISKS 15
 struct disk_desc {
 	char	dd_name[SSTRSIZE];
 	char	dd_descr[70];
@@ -86,7 +85,7 @@ static void fixsb(const char *, const char *, char);
 #define DISK_NAMES "wd", "sd", "ld", "raid"
 #endif
 
-static const char *disk_names[] = { DISK_NAMES, "vnd", NULL };
+static const char *disk_names[] = { DISK_NAMES, "vnd", "cgd", NULL };
 
 const char *
 getfslabelname(uint8_t f)
@@ -297,6 +296,7 @@ get_descr(struct disk_desc *dd)
 	/* try SCSI */
 	if (get_descr_scsi(dd, fd))
 		goto done;
+	/* TODO: get description from raid, cgd, vnd... */
 
 done:
 	if (fd >= 0)
@@ -349,22 +349,15 @@ get_disks(struct disk_desc *dd)
 	return numdisks;
 }
 
-static int
-set_dsk_select(menudesc *m, void *arg)
-{
-	*(int *)arg = m->cursel;
-	return 1;
-}
-
 int
 find_disks(const char *doingwhat)
 {
 	struct disk_desc disks[MAX_DISKS];
-	menu_ent dsk_menu[nelem(disks) + !partman_go];
+	menu_ent dsk_menu[nelem(disks) + 1]; // + 1 for extended partitioning entry
 	struct disk_desc *disk;
-	int i;
-	int numdisks;
-	int selected_disk = -1;
+	pm_devs_t *pm_i, *pm_swap;
+	int i, already_found;
+	int numdisks, selected_disk = -1;
 	int menu_no;
 
 	/* Find disks. */
@@ -376,77 +369,132 @@ find_disks(const char *doingwhat)
 	/* Kill typeahead, it won't be what the user had in mind */
 	fpurge(stdin);
 
-	if (numdisks == 0) {
-		/* No disks found! */
-		msg_display(MSG_nodisk);
-		process_menu(MENU_ok, NULL);
-		/*endwin();*/
-		return -1;
-	} else {
-		/* One or more disks found! */
-		for (i = 0; i < numdisks; i++) {
-			dsk_menu[i].opt_name = disks[i].dd_descr;
-			dsk_menu[i].opt_menu = OPT_NOMENU;
-			dsk_menu[i].opt_flags = OPT_EXIT;
-			dsk_menu[i].opt_action = set_dsk_select;
-		}
-		if (partman_go == 0) {
+	if (! partman_go) {
+		if (numdisks == 0) {
+			/* No disks found! */
+			msg_display(MSG_nodisk);
+			process_menu(MENU_ok, NULL);
+			/*endwin();*/
+			return -1;
+		} else {
+			/* One or more disks found! */
+			for (i = 0; i < numdisks; i++) {
+				dsk_menu[i].opt_name = disks[i].dd_descr;
+				dsk_menu[i].opt_menu = OPT_NOMENU;
+				dsk_menu[i].opt_flags = OPT_EXIT;
+				dsk_menu[i].opt_action = set_menu_select;
+			}
+			
 			dsk_menu[i].opt_name = "Extended partitioning"; // TODO: localize
 			dsk_menu[i].opt_menu = OPT_NOMENU;
 			dsk_menu[i].opt_flags = OPT_EXIT;
-			dsk_menu[i].opt_action = set_dsk_select;
+			dsk_menu[i].opt_action = set_menu_select;
+
+			menu_no = new_menu(MSG_Available_disks,
+				dsk_menu, numdisks + 1, -1, 4, 0, 0, MC_SCROLL,
+				NULL, NULL, NULL, NULL, NULL);
+			if (menu_no == -1)
+				return -1;
+			msg_display(MSG_ask_disk, doingwhat);
+			process_menu(menu_no, &selected_disk);
+			free_menu(menu_no);
 		}
-
-		menu_no = new_menu(MSG_Available_disks,
-			dsk_menu, numdisks + !partman_go, -1, 4, 0, 0,
-			MC_SCROLL,
-			NULL, NULL, NULL, NULL, NULL);
-		if (menu_no == -1)
-			return -1;
-		msg_display(MSG_ask_disk, doingwhat);
-		process_menu(menu_no, &selected_disk);
-		free_menu(menu_no);
-	}
-
-	if (selected_disk == -1)
-	    return -1;
-	if (selected_disk == numdisks) {
-		partman_go = 1;
-	    return -2;
+		if (selected_disk == numdisks) {
+			partman_go = 1;
+	    	return -2;
+		}
+		if (selected_disk < 0 || selected_disk >= numdisks)
+	    	return -1;
 	}
 
-	disk = disks + selected_disk;
-	pm = pm_found;
-	pm->bootable = 0;
-	strlcpy(pm->diskdev, disk->dd_name, sizeof pm->diskdev);
-	strlcpy(pm->diskdev_descr, disk->dd_descr, sizeof pm->diskdev_descr);
-
-	/* Use as a default disk if the user has the sets on a local disk */
-	strlcpy(localfs_dev, disk->dd_name, sizeof localfs_dev); // TODO: sss
-
-	pm->sectorsize = disk->dd_secsize;
-	pm->dlcyl = disk->dd_cyl;
-	pm->dlhead = disk->dd_head;
-	pm->dlsec = disk->dd_sec;
-	pm->dlsize = disk->dd_totsec;
-	pm->no_mbr = disk->dd_no_mbr;
-	if (pm->dlsize == 0)
-		pm->dlsize = disk->dd_cyl * disk->dd_head * disk->dd_sec;
-	if (pm->dlsize > UINT32_MAX) {
-		msg_display(MSG_toobigdisklabel);
-		process_menu(MENU_ok, NULL);
-		return -1;
+	/* Mark all devicec as not found */
+	for (pm_i = pm_head->next; partman_go && pm_i != NULL;
+		 pm_i = pm_i->next)
+			pm_i->found = 0;
+	/* Fill pm struct with device(s) info */
+	for (i = 0; i < numdisks; i++) {
+		if (! partman_go)
+			disk = disks + selected_disk;
+		else {
+			disk = disks + i;
+			already_found = 0;
+			for (pm_i = pm_head; pm_i->next != NULL; pm_i = pm_i->next)
+				if (!already_found && 
+						strcmp(pm_i->next->diskdev, disk->dd_name) == 0) {
+					pm_i->next->found = 1;
+					already_found = 1;
+				}
+			if (already_found)
+				/* We already added this device, skipping */
+				continue;
+		}
+		pm = pm_found;
+		pm->found = 1;
+		pm->bootable = 0;
+		pm->pi.menu_no = -1;
+		pm->disktype = "unknown";
+		pm->doessf = "";
+		strlcpy(pm->diskdev, disk->dd_name, sizeof pm->diskdev);
+		strlcpy(pm->diskdev_descr, disk->dd_descr, sizeof pm->diskdev_descr);
+		/* Use as a default disk if the user has the sets on a local disk */
+		strlcpy(localfs_dev, disk->dd_name, sizeof localfs_dev);
+
+		pm->sectorsize = disk->dd_secsize;
+		pm->dlcyl = disk->dd_cyl;
+		pm->dlhead = disk->dd_head;
+		pm->dlsec = disk->dd_sec;
+		pm->dlsize = disk->dd_totsec;
+		pm->no_mbr = disk->dd_no_mbr;
+		if (pm->dlsize == 0)
+			pm->dlsize = disk->dd_cyl * disk->dd_head * disk->dd_sec;
+		if (pm->dlsize > UINT32_MAX) {
+			if (logfp)
+				fprintf(logfp, "Cannot process disk %s: too big size (%d)\n",
+					pm->diskdev, (int)pm->dlsize); // TODO: localize
+			if (partman_go)
+				continue;
+			msg_display(MSG_toobigdisklabel);
+			process_menu(MENU_ok, NULL);
+			return -1;
+		}
+		pm->dlcylsize = pm->dlhead * pm->dlsec;
+
+		label_read();
+		if (partman_go) {
+			pm_i->next = pm_found;
+			pm_found = malloc(sizeof (pm_devs_t));
+			memset(pm_found, 0, sizeof *pm_found);
+			pm_found->next = NULL;
+		} else
+			/* We is not in partman and do not want to process all devices, exit */
+			break;
 	}
-	pm->dlcylsize = pm->dlhead * pm->dlsec;
+	for (pm_i = pm_head; partman_go && pm_i->next != NULL;
+			pm_i = pm_i->next)
+		if (! pm_i->next->found) {
+			/* If device not found then delete it */
+			if (pm_i->next->next == NULL) {
+				free(pm_i->next);
+				pm_i->next = NULL;
+				break;
+			} else {
+				pm_swap = pm_i->next->next;
+				free(pm_i->next);
+				pm_i->next = pm_swap;
+			}
+		}
+	return numdisks;
+}
 
+void
+label_read(void)
+{
 	/* Get existing/default label */
 	memset(&pm->oldlabel, 0, sizeof pm->oldlabel);
 	incorelabel(pm->diskdev, pm->oldlabel);
-
 	/* Set 'target' label to current label in case we don't change it */
 	memcpy(&pm->bsdlabel, &pm->oldlabel, sizeof pm->bsdlabel);
-
-	return numdisks;
+	savenewlabel(pm->oldlabel, getmaxpartitions());
 }
 
 void
@@ -797,10 +845,8 @@ make_fstab(void)
 	scripting_fprintf(NULL, "EOF\n");
 
 	fstab_prepared = 1;
-#ifndef DEBUG
 	fclose(f);
 	fflush(NULL);
-#endif
 	return 0;
 }
 
@@ -938,7 +984,7 @@ mount_root(void)
 {
 	int	error;
 
-	error = fsck_preen(pm->diskdev, rootpart, "ffs");
+	error = fsck_preen(pm->diskdev, pm->rootpart, "ffs");
 	if (error != 0)
 		return error;
 
@@ -950,7 +996,7 @@ mount_root(void)
 	 * XXX consider -o remount in case target root is
 	 * current root, still readonly from single-user?
 	 */
-	return target_mount("", pm->diskdev, rootpart, "");
+	return target_mount("", pm->diskdev, pm->rootpart, "");
 }
 
 /* Get information on the file systems mounted from the root filesystem.
@@ -1092,11 +1138,11 @@ bootxx_name(void)
 	char *bootxx;
 
 	/* check we have boot code for the root partition type */
-	fstype = pm->bsdlabel[rootpart].pi_fstype;
+	fstype = pm->bsdlabel[pm->rootpart].pi_fstype;
 	switch (fstype) {
 #if defined(BOOTXX_FFSV1) || defined(BOOTXX_FFSV2)
 	case FS_BSDFFS:
-		if (pm->bsdlabel[rootpart].pi_flags & PIF_FFSv2) {
+		if (pm->bsdlabel[pm->rootpart].pi_flags & PIF_FFSv2) {
 #ifdef BOOTXX_FFSV2
 			bootxxname = BOOTXX_FFSV2;
 #else
@@ -1129,288 +1175,30 @@ bootxx_name(void)
 }
 #endif
 
-
-
-
-void
-partman_select(pm_devs_t *pm_devs_in)
-{
-	pm = pm_devs_in;
-	if (logfp)
-		(void)fprintf(logfp,"Partman device: %s\n", pm->diskdev);
-	return;
-
-}
-
-// TODO: mount order
-static int
-partman_mountall_sort(const void *a, const void *b)
-{
-	return strcmp(mnts[*(const int *)a].pi_mount,
-		      mnts[*(const int *)b].pi_mount);
-}
-
-int
-partman_mountall(void)
-{
-	pm_devs_t *pm_devs_i;
-	int num_devs = 0;
-	int i, error;
-
-	int mnts_order[MNTS_MAX]; // TODO: rewrite
-	for (pm_devs_i = pm_devs->next, num_devs = 0; pm_devs_i != NULL;
-			pm_devs_i = pm_devs_i->next) {
-		fprintf(logfp,"::%s\n",pm_devs_i->diskdev); fflush(logfp);
-		for (i = 0; i < MAXPARTITIONS; i++) {
-			if (pm_devs_i->bsdlabel[i].pi_flags & PIF_MOUNT &&
-					pm_devs_i->bsdlabel[i].mnt_opts != NULL) {
-				mnts[num_devs].diskdev = pm_devs_i->diskdev;
-				mnts[num_devs].mnt_opts = pm_devs_i->bsdlabel[i].mnt_opts;
-				mnts[num_devs].fsname = pm_devs_i->bsdlabel[i].fsname;
-				mnts[num_devs].pi_mount = pm_devs_i->bsdlabel[i].pi_mount;
-				num_devs++;
-				fprintf(logfp,":::%s\n",mnts[num_devs].pi_mount); fflush(logfp);
-			}
-		}
-	}
-	for (i = 0; i < num_devs; i++)
-		mnts_order[i] = i;
-	qsort(mnts_order, num_devs, sizeof mnts_order[0], partman_mountall_sort);
-
-	for (i = 0; i < num_devs; i++) {
-		make_target_dir(mnts[i].pi_mount);
-		error = target_mount(mnts[i].mnt_opts, pm->diskdev, i, mnts[i].pi_mount);
-		if (error) {
-			msg_display(MSG_mountfail, pm->diskdev, 'a' + i, mnts[i].pi_mount);
-			process_menu(MENU_ok, NULL);
-			return error;
-		}
-	}
-	return 0;
-}
-
-int
-partman_adddisk(menudesc *m, void *arg)
-{
-	*(int *)arg = m->cursel + 1;
-	pm_devs_t *pm_devs_tmp;
-
-	if (find_disks(msg_string(MSG_install)) < 0)
-		return -1;
-
-	clear();
-	refresh();
-
-	if (check_swap(pm->diskdev, 0) > 0) {
-		msg_display(MSG_swapactive);
-		process_menu(MENU_ok, NULL);
-		if (check_swap(pm->diskdev, 1) < 0) {
-			msg_display(MSG_swapdelfailed);
-			process_menu(MENU_ok, NULL);
-			return -1;
-		}
-	}
-
-	for (pm_devs_tmp = pm_devs; pm_devs_tmp->next != NULL;
-			pm_devs_tmp = pm_devs_tmp->next)
-		if (strcmp(pm_devs_tmp->next->diskdev, pm->diskdev) == 0)
-			return 0;
-	pm_devs_tmp->next = pm_found;
-
-	pm_found = malloc(sizeof (pm_devs_t));
-	pm_found->next = NULL;
-
-	return 0;
-}
-
-int
-partman_addvnd(menudesc *m, void *arg)
-{
-	*(int *)arg = m->cursel + 1;
-	return 0;
-}
-
-int
-partman_deldev(menudesc *m, void *arg)
-{
-	pm_devs_t *pm_devs_tmp, *pm_devs_swap;
-	*(int *)arg = m->cursel + 1;
-
-	for (pm_devs_tmp = pm_devs; pm_devs_tmp->next != NULL;
-			pm_devs_tmp = pm_devs_tmp->next)
-		if (pm_devs_tmp->next == pm) {
-			if (pm_devs_tmp->next->next == NULL) {
-				free(pm_devs_tmp->next);
-				pm_devs_tmp->next = NULL;
-			} else {
-				pm_devs_swap = pm_devs_tmp->next->next;
-				free(pm_devs_tmp->next);
-				pm_devs_tmp->next = pm_devs_swap;
-			}
-			return 0;
-		}
-	return -1;
-}
-
-int
-partman_commit(menudesc *m, void *arg)
-{
-	pm_devs_t *pm_devs_i;
-	*(int *)arg = m->cursel + 1;
-
-	for (pm_devs_i = pm_devs->next; pm_devs_i != NULL;
-			pm_devs_i = pm_devs_i->next) {
-		partman_select(pm_devs_i);
-		if (
-				md_pre_disklabel() != 0  || /* Write partition table */
-				write_disklabel() != 0   || /* Write slices table (disklabel) */
-				md_post_disklabel() != 0 || /* Enable swap and check badblock */
-				make_filesystems()          /* Create filesystems by newfs */
-			) { /* If something fails... */
-			return -1;
-		}
-		/* Write bootsector if needed */
-		if (pm_devs_i->bootable && md_post_newfs() != 0) {
-			return -1;
-		}
-	}
-    return 0;
-}
-
-static int
-partman_submenu(menudesc *m, void *arg)
-{
-	pm_devs_t *pm_devs_i;
-	int retvalue;
-	int ok = 0;
-	int i;
-	*(int *)arg = m->cursel + 1;
-
-	/* write selected disk to diskdev variable */
-	for (pm_devs_i = pm_devs->next, i = 0; !ok && pm_devs_i != NULL;
-			pm_devs_i = pm_devs_i->next, i++)
-		if (i == m->cursel) {
-			partman_select(pm_devs_i);
-			ok = 1;
-			break;
-		}
-	if (!ok)
-		return -1;
-
-	process_menu(MENU_pmentry, &retvalue);
-	return 0;
-}
-
-void
-partman_menufmt(menudesc *m, int ptn, void *arg)
-{
-	pm_devs_t *pm_devs_i;
-	int i;
-	unsigned int maxpart;
-	char *dev_mounts = malloc(STRSIZE * sizeof(char));
-	dev_mounts[0] = '\0';
-
-	for (pm_devs_i = pm_devs->next, i = 0;
-			i != ptn && pm_devs_i != NULL;
-			pm_devs_i = pm_devs_i->next, i++);
-	if (i != ptn || pm_devs_i == NULL) 
-		return;
-
-	maxpart = ((unsigned int)getmaxpartitions() > nelem(pm_devs_i->bsdlabel))?
-				nelem(pm_devs_i->bsdlabel) : (unsigned int)getmaxpartitions();
-	for (i = 0; (unsigned int)i < maxpart; i++) {
-		if (pm_devs_i->bsdlabel[i].pi_mount != 0 &&
-				pm_devs_i->bsdlabel[i].pi_fstype != FS_UNUSED) {
-			strcat(dev_mounts, pm_devs_i->bsdlabel[i].pi_mount);
-			strcat(dev_mounts, " ");
-		}
-	}
-
-	wprintw(m->mw,"%-25s %-20s %4s", pm_devs_i->diskdev_descr, dev_mounts,
-			(pm_devs_i->bootable)?"BOOT":"" );
-	return;
-}
-
-// TODO: switch to langfiles
-// TODO: resolve case with 2 same bsddisknames
-int
-partman(void)
+const char *
+fstype_name(int fstype)
 {
-	menu_ent part_menu[MAX_DISKS];
-	int menu_pm;
-	int i, ii;
-	int retvalue = 0;
-	pm_devs_t *pm_devs_i;
-
-	do {
-		clear();
-		refresh();
-		for (pm_devs_i = pm_devs->next, i = 0; pm_devs_i != NULL;
-				pm_devs_i = pm_devs_i->next, i++) {
-			part_menu[i].opt_name = NULL;
-			part_menu[i].opt_action = partman_submenu;
-		}
-
-		part_menu[i] = (struct menu_ent) {
-			.opt_name = "Add disk",
-			.opt_action = partman_adddisk,
-		};
-		part_menu[++i] = (struct menu_ent) {
-			.opt_name = "Create CGD",
-			.opt_action = partman_addvnd,
-		};
-		part_menu[++i] = (struct menu_ent) {
-			.opt_name = "Create VND disk",
-			.opt_action = partman_addvnd,
-		};
-		part_menu[++i] = (struct menu_ent) {
-			.opt_name = "Create LVM VG",
-			.opt_action = partman_addvnd,
-		};
-		part_menu[++i] = (struct menu_ent) {
-			.opt_name = "Create RAIFframe",
-			.opt_action = partman_addvnd,
-		};
-		part_menu[++i] = (struct menu_ent) {
-			.opt_name = "Commit changes",
-			.opt_action = partman_commit,
-		};
-
-		for (ii = 0; ii <= i; ii++) {
-			part_menu[ii].opt_menu = OPT_NOMENU;
-			part_menu[ii].opt_flags = OPT_EXIT;
-		}
-
-		menu_pm = new_menu("Disk editor. All disks, partitions, LVM, RAID displayed there.\nAt first add drive, then prepare partitions and go.",
-			part_menu, i+1,	1, 1, 0, 0, MC_ALWAYS_SCROLL | MC_NOBOX | MC_NOCLEAR,
-			NULL, partman_menufmt, NULL, NULL, NULL);
-		retvalue = 0;
-		if (menu_pm == -1)
-			retvalue = -1;
-		else {
-			process_menu(menu_pm, &retvalue);
-			free_menu(menu_pm);
-		}
-
-		if (logfp)
-			(void)fprintf(logfp, "partman retvalue is %d\n", retvalue);
-	} while (retvalue > 0);
-	
-	// TODO: check_partitions()
-	/* Check that fstab on target device is readable - if so then we can go */
-	if (retvalue == 0) {
-		if (partman_mountall() != 0 ||
-			make_fstab() != 0)
-			retvalue = -1;
-		else {
-			FILE *file_tmp = fopen(concat_paths(targetroot_mnt, "/etc/fstab"), "r");
-			if (file_tmp == NULL)
-				retvalue = -1;
-			else
-				fclose(file_tmp);
-		}
+	switch (fstype) {
+		case FS_BSDFFS:
+			return "FFS";
+		case FS_BSDLFS:
+			return "LFS";
+		case FS_SWAP:
+			return "SWAP";
+		case FS_EX2FS:
+			return "EXT2";
+		case FS_MSDOS:
+			return "FAT";
+		case FS_APPLEUFS:
+			return "APPLEUFS";
+		case FS_SYSVBFS:
+			return "SYSVB";
+		case FS_RAID:
+			return "RAID";
+		case FS_CGD:
+			return "CGD";
+		case FS_UNUSED:
+			return "none";
 	}
-
-	/* retvalue <0 - error, retvalue ==0 - user quits, retvalue >0 - all ok */
-	return (retvalue >= 0)?0:-1;
-}
+	return "???";
+}
\ No newline at end of file
diff --git a/distrib/utils/sysinst/label.c b/distrib/utils/sysinst/label.c
index ebdb567..a91e866 100644
--- a/distrib/utils/sysinst/label.c
+++ b/distrib/utils/sysinst/label.c
@@ -161,7 +161,7 @@ check_one_root(partinfo *lp, int nparts)
 			return 0;
 		foundroot = 1;
 		/* Save partition number, a few things need to know it */
-		rootpart = part;
+		pm->rootpart = part;
 	}
 	return foundroot;
 }
diff --git a/distrib/utils/sysinst/main.c b/distrib/utils/sysinst/main.c
index 69723e8..c7592a6 100644
--- a/distrib/utils/sysinst/main.c
+++ b/distrib/utils/sysinst/main.c
@@ -76,6 +76,8 @@ struct {
 
 /* String defaults and stuff for processing the -f file argument. */
 
+static char bsddiskname[DISKNAME_SIZE]; /* default name for fist selected disk */
+
 struct f_arg {
 	const char *name;
 	const char *dflt;
@@ -105,7 +107,7 @@ static const struct f_arg fflagopts[] = {
 	{"local dir", "release", localfs_dir, sizeof localfs_dir},
 	{"targetroot mount", "/targetroot", targetroot_mnt, sizeof targetroot_mnt},
 	{"dist postfix", ".tgz", dist_postfix, sizeof dist_postfix},
-	{"diskname", "mydisk", bsddiskname, sizeof bsddiskname}, /* TODO: xxx */
+	{"diskname", "mydisk", bsddiskname, sizeof bsddiskname},
 	{"pkg host", SYSINST_PKG_HOST, pkg.host, sizeof pkg.host},
 	{"pkg dir", SYSINST_PKG_DIR, pkg.dir, sizeof pkg.dir},
 	{"pkg prefix", "/" MACH "/" REL "/All", pkg_dir, sizeof pkg_dir},
@@ -128,20 +130,20 @@ init(void)
 	const struct f_arg *arg;
 	
 	sizemult = 1;
-	disktype = "unknown";
 	tmp_ramdisk_size = 0;
-	doessf = "";
 	clean_xfer_dir = 0;
 	mnt2_mounted = 0;
 	fd_type = "msdos";
+	layoutkind = LY_SETNEW;
 
-	pm_devs = malloc (sizeof (pm_devs_t));
-	pm_devs->next = NULL;
+	pm_head = malloc (sizeof (pm_devs_t));
+	memset(pm_head, 0, sizeof *pm_head);
 	pm_found = malloc (sizeof (pm_devs_t));
-	pm_found->next = NULL;
+	memset(pm_found, 0, sizeof *pm_found);
 
 	for (arg = fflagopts; arg->name != NULL; arg++)
 		strlcpy(arg->var, arg->dflt, arg->size);
+	strlcpy(pm_found->bsddiskname, bsddiskname, sizeof pm_found->bsddiskname);
 	pkg.xfer_type = pkgsrc.xfer_type = "http";
 	
 	clr_arg.bg=COLOR_BLUE;
@@ -360,7 +362,7 @@ toplevel(void)
 	 * XXX must be idempotent, since we get run each time the main
 	 *     menu is displayed.
 	 */
-	chdir(getenv("HOME")? getenv("HOME") : "/");
+	chdir(getenv("HOME"));
 	unwind_mounts();
 
 	/* Display banner message in (english, francais, deutsch..) */
@@ -496,6 +498,7 @@ process_f_flag(char *f_name)
 			break;
 		}
 	}
+	strlcpy(pm_found->bsddiskname, bsddiskname, sizeof pm_found->bsddiskname);
 
 	fclose(fp);
 }
diff --git a/distrib/utils/sysinst/mbr.c b/distrib/utils/sysinst/mbr.c
index c916074..d93ef25 100644
--- a/distrib/utils/sysinst/mbr.c
+++ b/distrib/utils/sysinst/mbr.c
@@ -1272,8 +1272,12 @@ edit_mbr(mbr_info_t *mbri)
 
 	part = &mbrs->mbr_parts[0];
 	get_ptn_alignment(part);  /* update ptn_alignment */
-	msg_display(MSG_fullpart, pm->diskdev);
-	process_menu(MENU_fullpart, &usefull);
+	if (partman_go)
+		usefull = 0;
+	else {
+		msg_display(MSG_fullpart, pm->diskdev);
+		process_menu(MENU_fullpart, &usefull);
+	}
 
 	/* DOS fdisk label checking and value setting. */
 	if (usefull) {
diff --git a/distrib/utils/sysinst/menus.mi b/distrib/utils/sysinst/menus.mi
index 08c8d1f..6fd5a1e 100644
--- a/distrib/utils/sysinst/menus.mi
+++ b/distrib/utils/sysinst/menus.mi
@@ -177,7 +177,7 @@ menu utility, title MSG_NetBSD_VERSION_Utilities, exit,
 			network_up = 0;
 			config_network();
 		};
-	option MSG_Partition_a_disk, action { partman(); };
+	option MSG_Partition_a_disk, action { partman_go = 1; partman(); };
 	option MSG_Logging_functions, action { do_logging(); };
 	option MSG_Color_scheme, sub menu colors;
 	option MSG_Halt_the_system, exit,
@@ -206,8 +206,8 @@ menu ok, no shortcut, y=-10;
 	option MSG_Hit_enter_to_continue, exit;
 
 menu layout, sub menu, y=-1, title  MSG_Choose_your_installation;
-	option MSG_Set_Sizes, 	  exit, action { layoutkind = 1; };
-	option MSG_Use_Existing,  exit, action { layoutkind = 4; };
+	option MSG_Set_Sizes, 	  exit, action { layoutkind = LY_SETNEW; };
+	option MSG_Use_Existing,  exit, action { layoutkind = LY_USEEXIST; };
 
 menu sizechoice, sub menu, y=0, title MSG_Choose_your_size_specifier;
 	display action {
@@ -241,7 +241,7 @@ menu distmedium, title MSG_Select_medium, y=-5;
 	option MSG_Skip_group,exit, action { *(int *)arg = SET_SKIP_GROUP; };
 	option MSG_Abandon,   exit, action { *(int *)arg = SET_ABANDON; };
 
-menu distset, title MSG_Select_your_distribution, exit;
+menu distset, title MSG_Select_your_distribution, exit, no default exit;
 	display action { msg_display (MSG_distset); };
 	option MSG_Full_installation, exit, action { *(int *)arg = 1; init_set_status(0);  };
 	option MSG_Full_installation_nox, exit, action { *(int *)arg = 1; init_set_status(SFLAG_NOX); };
@@ -506,11 +506,72 @@ menu pkgsrc, y=-4, x=0, w=70, no box, no clear,
 		};
 	option MSG_quit_install, exit, action { yesno = SET_SKIP; };
 
-menu pmentry, x=50, y=5, sub menu, exit, default exit;
-	option "Prepare",			exit, action { md_get_info(); };
-	option "Prepare GPT",		exit, action { md_get_info(); };
-	option "Commit prepare",	exit, action { md_pre_disklabel(); };
-	option "Disk label",		exit, action { md_make_bsd_partitions(); };
-	option "Commit label",		exit, action { write_disklabel(); md_post_disklabel(); };
-	option "Toggle bootable",   exit, action { pm->bootable = !pm->bootable; };
-	option "Remove",			exit, action { partman_deldev(m, arg); };
+menu pmentry, x=50, y=5, exit, default exit; /* TODO: localize */
+	option "Prepare MBR",		exit, action { pm->changed = 1; md_get_info(); };
+	option "Prepare GPT [WIP]",	exit, action { pm->changed = 1; };
+	option "Edit BSD partitions", exit, action { *(int *)arg = 1; pm->changed = 1;
+								layoutkind = LY_SETNEW;
+								md_make_bsd_partitions();
+								if (pm->bsdlabel[pm->rootpart].pi_flags & PIF_MOUNT)
+									pm->bootable = 1;
+								else
+									pm->bootable = 0; };
+	option "Set disk name",		exit, action { msg_prompt_win(MSG_packname, -1,
+								18,	0, 0, pm->bsddiskname, pm->bsddiskname,
+								sizeof pm->bsddiskname); };
+	option "RAID there",		exit, action { *(int *)arg = 1; pm->changed = 1;
+												layoutkind = LY_NEWRAID;
+												md_make_bsd_partitions(); };
+	option "Encrypt",			exit, action { *(int *)arg = 1; pm->changed = 1;
+												layoutkind = LY_NEWCGD;
+												md_make_bsd_partitions();
+												partman_cgd_edit_adddisk(0, pm); };
+	option "Bootable flag",		exit, action { pm->changed = 1;
+												pm->bootable = !pm->bootable; };
+	option "Safe erase",		next menu shred_modes;
+	option "Undo changes",		exit, action { label_read(); pm->changed = 0; };
+	option "Mount...",			exit, action { partman_mountmenu(); };
+	option "Umount/Unconfigure", exit, action { *(int *)arg = 1;
+												partman_unconfigure(); };
+
+menu shred_modes, x=50, y=5, exit, default exit;
+	option "Fill by zeros",			exit, action { partman_shred(pm->diskdev,
+													SHRED_ZEROS); };
+	option "Fill by random data",	exit, action { partman_shred(pm->diskdev,
+													SHRED_RANDOM); };
+	option "Fill by crypto data",	exit, action { partman_shred(pm->diskdev,
+													SHRED_CRYPTO); };
+
+menu raidlevel;
+	option "0 - No parity, only simple striping.", exit,
+		action { *(int *)arg = 0; };
+	option "1 - Mirroring.  The parity is the mirror.", exit,
+		action { *(int *)arg = 1; };
+	option "4 - Striping with parity stored on the last component.", exit,
+		action { *(int *)arg = 4; };
+	option "5 - Striping with parity at the all components.", exit,
+		action { *(int *)arg = 5; };
+
+menu cgd_enctype;
+	option "aes-cbc",			exit, action { *(const char**)arg = "aes-cbc"; };
+	option "3des-cbc",			exit, action { *(const char**)arg = "3des-cbc"; };
+	option "blowfish-cbc",		exit, action { *(const char**)arg = "blowfish-cbc"; };
+
+menu cgd_ivtype;
+	option "encblkno1",			exit, action { *(const char**)arg = "encblkno1"; };
+	option "encblkno8",			exit, action { *(const char**)arg = "encblkno8"; };
+
+menu cgd_keygentype;
+	option "pkcs5_pbkdf2/sha1",	exit, action { *(const char**)arg = "pkcs5_pbkdf2/sha1"; };
+	option "pkcs5_pbkdf2",		exit, action { *(const char**)arg = "pkcs5_pbkdf2"; };
+	option "storedkey",			exit, action { *(const char**)arg = "storedkey"; };
+	option "randomkey",			exit, action { *(const char**)arg = "randomkey"; };
+	option "urandomkey",		exit, action { *(const char**)arg = "urandomkey"; };
+	option "shell_cmd",			exit, action { *(const char**)arg = "shell_cmd"; };
+
+menu cgd_verifytype;
+	option "none",				exit, action { *(const char**)arg = "none"; };
+	option "disklabel",			exit, action { *(const char**)arg = "disklabel"; };
+	option "ffs",				exit, action { *(const char**)arg = "ffs"; };
+	option "re-enter",			exit, action { *(const char**)arg = "re-enter"; };
+
diff --git a/distrib/utils/sysinst/net.c b/distrib/utils/sysinst/net.c
index 100331a..90d6b7a 100644
--- a/distrib/utils/sysinst/net.c
+++ b/distrib/utils/sysinst/net.c
@@ -510,13 +510,6 @@ handle_license(const char *dev)
 	return 1;
 }
 
-static int
-set_net_select(menudesc *m, void *arg)
-{
-	*(int *)arg = m->cursel;
-	return 1;
-}
-
 /*
  * Get the information to configure the network, configure it and
  * make sure both the gateway and the name server are up.
@@ -564,7 +557,7 @@ config_network(void)
 		net_menu[i].opt_name = net_devs[i].if_dev;
 		net_menu[i].opt_menu = OPT_NOMENU;
 		net_menu[i].opt_flags = OPT_EXIT;
-		net_menu[i].opt_action = set_net_select;
+		net_menu[i].opt_action = set_menu_select;
 	}
 again:
 	selected_net = -1;
